#include "vW_abwehr.h"

void Abwehr::Behave()
{
    if (!Mem->MyConf()) {
	    Mem->LogAction2(10, "Don't know where I am, scanning field");
	    scan_field_with_body();
	    return;
	}

    Vector ActualControlPosition = MyStartPosition;
    
    if (Mem->BallPositionValid())
    {
	
	/* Wenn der Ball hinter die eigene Startposition gelangt ist,
	   wird der Kontrollraum entsprechend nach hinten verlagert */
	
	if (Mem->BallAbsolutePosition().x<MyStartPosition.x)
	    ActualControlPosition.x = (Mem->BallAbsolutePosition().x)-2;
	
	
	/* Ist der Ball spielbar, wird entweder zu einem besser stehenden 
	   Mitspieler gepasst, oder einfach nach vorne gekellt; Ist es 
           nicht moeglich den Ball nach vorne zu spielen, soll er ins
           Seitenaus*/
	
	if (Mem->BallKickable() )
	{
	    int TeammateToPassBall=findTeammateToPassBall();
	    if(TeammateToPassBall)
	    {
		pass_ball(TeammateToPassBall);
		return;
	    }
	    if (Mem->AmIInCone(50, 
			  Mem->MarkerPosition(Mem->RM_Their_Goal), 
			  Mem->BallAbsolutePosition())
		)
		kick(100,
		     Mem->AngleToFromBody(Vector(Mem->MyPos().x,
					  ((Mem->MyPos().y)*2))));
	    else
		kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
	} 
	else {
	    if (!((Mem->team_passer == Mem->MyNumber) && 
		  (Mem->team_pass_time > Mem->CurrentTime-100) && 
		  (!Mem->PlayerWithBall()<0)))
	    {
		
		/* Ball holen, wenn er in den Kontrollraum kommt, oder wenn
		   kein Mitspieler nher dran ist */
		
		if(fabs(ActualControlPosition.x-Mem->BallAbsolutePosition().x)
		   +fabs(ActualControlPosition.y-Mem->BallAbsolutePosition().y)
		   <ActionRadius || (Mem->NumTeammatesCloserToBall()==0))
		{
		    get_ball();
		    return;
		}
	    }
	}
	
	if (GoToPointFaceBall(ActualControlPosition,50))
	    face_neck_and_body_to_ball();
    }
    
    /* Wenn sich nur ein Gegenspieler im nheren (Hlfte) Kontrollraum 
       befindet, kommt er in Manndeckung */


    /* Idee: mit turn_neck_to_relative_angle(PI), alle 50/52 o. 
       (zwei Zahlen mit einem ziemlich hohen gemeinsamen Vielfachen...)
       Zyklen um 180 Grad drehen....*/
    /* 
    if (Mem->NumOpponentsWithin(ActionRadius/2, 
				ActualControlPosition)==1)
    {
	float Faktor;
	
	if (Mem->OpponentAbsolutePosition(
	    Mem->ClosestOpponentTo(ActualControlPosition)).y>0)
	    Faktor = -0.5;
	else
	    Faktor = 0.5;
    */    
/*	GoToPointFaceOpponent(Vector(
	(Mem->OpponentAbsolutePosition(Mem->ClosestOpponentTo(ActualControlPosition)).x)-0.5,
	(Mem->OpponentAbsolutePosition(Mem->ClosestOpponentTo(ActualControlPosition)).y)-Faktor),
	Mem->ClosestOpponentTo(ActualControlPosition),50,0.1);
*/
/*	GoToPointFaceBall(Vector(
	    (Mem->OpponentAbsolutePosition(
		Mem->ClosestOpponentTo(ActualControlPosition)).x)-0.5,
	    (Mem->OpponentAbsolutePosition(
		Mem->ClosestOpponentTo(ActualControlPosition)).y)-Faktor)
			  ,50,0.1);
	
	return;
	
    }
    
    else 
*/
	/* Gehe ungefhr in die Mitte deines Kontrollraumes */

    else scan_field_with_body();

}


void Baumann::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	Abwehr::Behave();
    }
}



void Barten::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	Abwehr::Behave();
    }
}


void Wicky::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	Abwehr::Behave();
    }
    
}


void Skripnik::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	Abwehr::Behave();
    }
}


void Tjikuzu::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	Abwehr::Behave();
    }
}


void Wiedener::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{
	Abwehr::Behave();
    }
}



void Eilts::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else{	
	Abwehr::Behave();
    }
}


void Cesar::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	move(MyStartPosition);
    else {
	if (!Mem->MyConf()) {
	    Mem->LogAction2(10, "Don't know where I am, scanning field");
	    scan_field_with_body();
	    return;
	}
	
	if (Mem->BallKickable() )
	{
	    int TeammateToPassBall=findTeammateToPassBall();
	    if(TeammateToPassBall)
	    {
		pass_ball(TeammateToPassBall);
		return;
	    }
	    kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
	} 
	else 
	{
	    if(Mem->BallInOwnPenaltyArea())
		get_ball();
	    else
		GoToPointFaceBall(MyStartPosition, 50, 2.5);
	}
    }
}

     




